#pragma once
#include<iostream>
using namespace std;

// 
typedef struct BitNode
{
	int data;
	BitNode* lchild, * rchild;
	int ltag = 0, rtag = 0;
	BitNode* parent;
}*BTree, ThreadNode, * ThreadTree;

// ڵ
typedef struct StackNode
{
	BitNode* nodePtr;
	// жϴ
	char flag;
	StackNode* next; //һڵ
	StackNode* pre; //ǰһڵ
}*StackPtr;
//==============ջز
//ջ
typedef struct LStack
{
	BTree elem; //
	LStack* next; //ָ
}*LinkStack;
//ջʼ
void InitLS(LinkStack& ls)
{
	ls = new LStack;
	ls->next = NULL;
}
//ѹջ
void push(LinkStack& ls, BTree e)
{
	LinkStack p = new LStack; //½ڵ
	p->elem = new BitNode;
	p->elem = e; //Ҫѹջݷ½ڵ
	p->next = ls; //½ڵѹջ
	ls = p; //ջͷָƵ½ڵ㣬ԴﵽջĲ
}
//ջ
void pop(LinkStack& ls, BTree& e)
{
	if (ls == NULL)
	{
		cout << "ջ޷ջ" << endl;
		exit(0);
	}
	else
	{
		e = ls->elem; //ջԪص
		LinkStack t = new LStack; //ʱڵջԪصĵַԴͷŸýڵ
		t = ls;
		ls = ls->next; //ջջԪջǰһλ
		delete t; //ͷԭջԪصڴռ
	}
}
//ȡջԪ
void gettop(LinkStack ls, BTree& e)
{
	if (ls != NULL)
	{
		e = ls->elem;
	}
}
//жջǷǿջ
bool stackempty(LinkStack ls)
{
	if (ls->next == NULL)
		return true;
	return false;
}
//ջ
void free(LinkStack ls)
{
	delete ls;
}
//==========================
//ͷ
StackPtr S, Head;
//ʼ
void InitStack(StackPtr& s)
{
	s = new StackNode;
	s->flag = 'L';
	s->next = NULL;
	s->pre = NULL;
}
//
StackNode* r = new StackNode;
//ڵ㣬ҪصڵĲ
BTree root;
//Ӷڵ㣬ʹ
void addNode(BTree& treeHead, int num)
{
	if (S == NULL)
	{
		cout << "ջδʼ!" << endl;
		exit(0);
	}
	else
	{
		if (S->next == NULL)
		{
			r = S;//ָʾ
		}
		if (treeHead == NULL)
		{
			StackNode* newS = new StackNode; //½һͷڵ
			newS->next = NULL;
			newS->pre = r;//ͷڵǰһڵΪַ
			r->next = newS; //ڵӵ
			r = newS;
			treeHead = new BitNode; //ʼڵ㣬ڵĵַͷ
			root = new BitNode;
			root = treeHead;
			treeHead->lchild = NULL;
			treeHead->rchild = NULL;
			treeHead->parent = NULL;
			r->nodePtr = new BitNode;
			r->nodePtr = treeHead;
			r->nodePtr->data = num; //ڵ
			r->flag = 'L'; //ָʾһ
		}
		else if (treeHead != NULL)
		{
			BTree newnode = new BitNode;  //һڵ
			newnode->data = num; //ڵ
			newnode->lchild = NULL;
			newnode->rchild = NULL;
			if (r->flag == 'L') //жϵǰеĶڵǷҪ
			{
				r->nodePtr->lchild = new BitNode;
				r->nodePtr->lchild = newnode; //½ڵӵ
				newnode->parent = r->nodePtr; //ĸڵΪǰڵ
				StackNode* newS = new StackNode; //½ڵ㣬ڴŶһĹϢ
				newS->next = NULL;
				newS->pre = r;//½ڵǰһڵΪͣĵǰڵ
				newS->nodePtr = new BitNode;
				newS->nodePtr = r->nodePtr->lchild; //½ڵĶڵ㹴ѹõ
				newS->flag = 'L';
				r->next = newS; //ʹµڵӵ
				r = newS; //ƶλ
			}
			else if (r->flag == 'R')//жϵǰеĶڵǷҪ
			{
				if (r->nodePtr == root) //ҪǸڵ
				{
					r->nodePtr->rchild = new BitNode;
					r->nodePtr->rchild = newnode;//½ڵӵ
					r->nodePtr->rchild->parent = r->nodePtr;//ĸڵΪǰڵ
				}
				else //ͨ
				{
					r->nodePtr->rchild = new BitNode;
					r->nodePtr->rchild = newnode;//½ڵӵ
					newnode->parent = r->nodePtr;//ĸڵΪǰڵ
				}
				StackNode* newS = new StackNode; // ½ڵ㣬ڴŶһĹϢ
				newS->next = NULL;
				newS->pre = r;//½ڵǰһڵΪͣĵǰڵ
				newS->nodePtr = new BitNode;
				newS->nodePtr = r->nodePtr->rchild;//½ڵĶڵ㹴ѹõ
				newS->flag = 'L';
				r->next = newS;//ʹµڵӵ
				r = newS;//ƶλ
			}
		}
	}
}
//ж϶ڵǷΪҶӽڵ㣬ǷTrue򷵻false
bool IsLeaf(BTree t)
{
	if (t->lchild == NULL && t->rchild == NULL)
	{
		return true;
	}
	return false;
}
//Ҫ
void processEmptyData()
{
	if (r->flag == 'L') //Ҫ죬ֻ轫־Ϊ
	{
		r->flag = 'R';
	}
	else if (r->flag == 'R')//Ҫ
	{
		if (r->nodePtr->parent->rchild != NULL)
		{
			if (IsLeaf(r->nodePtr->parent->lchild)) //ifγжϵǰڵǴҶӴ
			{
				r->pre = S->next;//ǰڵǰһڵΪͷ
				r->nodePtr = root; //ǰڵƶڵ㴦
			}
		}
		r->nodePtr = r->pre->nodePtr; //ͨ£Ҫʱǰһλ
										//ʹڵ˳ԹĶǰһڵ
	}
}
//ڵѹʱҪеĲ
void processEndData()
{
	StackNode* end = r;
	S = Head; //Ԫڵƶ
	r = S; //ͣŻԪ
	delete end;//ͷŶڵ
}
//
void createBiTreeNonRecursive(BTree& treeHead)
{
	int num;
	bool keepRun = true;
	treeHead = NULL;
	InitStack(S);//ʼ
	Head = new StackNode;
	Head = S;//־Ԫڵַ
	cout << "밴չĽݣ" << endl;
	while (keepRun)
	{
		cin >> num; //뼴ӵڵе
		switch (num) //жֵ
		{
		case -1://-1תҪĲ
			processEmptyData();
			continue;
		case 0://0,תϵĲ
			processEndData();
			keepRun = false; //ֹѭ
			break;
		default: //0-1ֵתڵĲ
			addNode(treeHead, num);
		}
	}
}
//Ҷ
int leaf = 0;
//Ҷ
void leafCount(BTree rt)
{
	if (rt != NULL)
	{
		leafCount(rt->lchild);
		leafCount(rt->rchild);
		if (rt->lchild == NULL && rt->rchild == NULL)//ǰڵҶӣҶһ
			leaf++;
	}
}
//ڵ
int node(BTree rt)
{
	if (rt == NULL)
		return 0;
	int leftcount = node(rt->lchild);
	int rightcount = node(rt->rchild);
	int ret = leftcount + rightcount + 1;
	return ret;
}
//==============ݹ==============
void rDLR(BTree rt)
{
	if (rt)
	{
		cout << rt->data << " "; //ڵ
		rDLR(rt->lchild); //ٱ
		rDLR(rt->rchild);//
	}
}
//========================================
//===========ǵݹ
void DLR(BTree rt)
{
	LinkStack ls;
	BTree p = new BitNode;
	BTree q = new BitNode;
	p = rt;
	int count = 0;
	InitLS(ls);
	if (p == NULL)
	{
		cout << "" << endl;
		return;
	}
	while (p || !stackempty(ls))
	{
		if (count == leaf)  //ǰڵǶһҶӽڵʱ 
		{
			free(ls);
			return;
		}
		if (p)
		{
			if (p != NULL)
			{
				push(ls, p); //ķǿսڵѹջ
			}
			cout << p->data << " "; //ڵ
			p = p->lchild; //ٱ
		}
		else
		{
			pop(ls, q); //ջеķǿնڵ
			p = q->rchild; //
		}
		if (IsLeaf(q)) //ۼҶ
		{
			count++;
		}
	}
}
//========ݹ㷨
void rLDR(BTree rt)
{
	if (rt)
	{
		rLDR(rt->lchild);//ȱ
		cout << rt->data << " ";//ڵ
		rLDR(rt->rchild);//
	}
}
//ǵݹ㷨
int size2 = 0;
void LDR(BTree rt)
{
	LinkStack ls;
	BTree p = new BitNode;
	BTree q = new BitNode;
	p = rt;
	size2 = node(rt);
	int nodecount = 0;
	int count = 0;//ڵ
	InitLS(ls);
	if (p == NULL)
	{
		cout << "" << endl;
		return;
	}
	while (p || !stackempty(ls))
	{
		if (leaf != 1) //ֻ
		{
			if (count == leaf && nodecount == size2)//ǰڵǶһҶӽڵѾеĽڵʱ 
												//
			{
				free(ls);
				return;
			}
			if (p)
			{
				if (p != NULL)
				{
					push(ls, p);//ķǿսڵѹջ
				}
				p = p->lchild; //ȱ
			}
			else
			{
				pop(ls, q);//ջеķǿնڵ
				cout << q->data << " "; //ڵ
				nodecount++;//ۼѾĽڵĿ
				if (q->rchild != NULL)
				{
					p = q->rchild; //
				}
			}
			if (IsLeaf(q))//ۼҶ
			{
				count++;
			}
		}
		else if (leaf == 1) //ֻ
		{
			if (rt->lchild != NULL && rt->rchild == NULL) //ֻ
			{
				if (p)
				{
					if (p != NULL)
					{
						push(ls, p);//ķǿսڵѹջ
					}
					p = p->lchild;//
				}
				else
				{
					pop(ls, q);//ջеķǿնڵ
					cout << q->data << " "; //Ķڵ
					if (q == root) //صڵʱ
					{
						free(ls);
						return;
					}
				}
			}
			else if (rt->rchild != NULL && rt->lchild == NULL) //ֻ
			{
				if (p)
				{
					if (p != NULL)
					{
						push(ls, p);//ķǿսڵѹջ
					}
					p = p->rchild;//
				}
				else
				{
					pop(ls, q);//ջеķǿնڵ
					cout << q->data << " ";//Ķڵ
					if (q == root)//صڵʱ
					{
						free(ls);
						return;
					}
				}
			}
		}
	}
}
//ݹ㷨
void rLRD(BTree rt)
{
	if (rt)
	{
		rLRD(rt->lchild);//ȱ
		rLRD(rt->rchild);//ڱ
		cout << rt->data << " "; //ڵ
	}
}
//ǵݹ㷨
void LRD(BTree rt)
{
	LinkStack ls;
	BTree cur, pre;
	InitLS(ls);
	if (rt == NULL)
	{
		cout << "Ϊ" << endl;
		return;
	}
	//ǰһڵ
	pre = NULL;
	//ǰڵ
	cur = NULL;
	push(ls, rt);//ȰѸڵѹջ
	while (!stackempty(ls))
	{
		cur = NULL;
		gettop(ls, cur);
		if ((cur->lchild == NULL && cur->rchild == NULL) || (pre != NULL && (pre == cur->lchild || pre == cur->rchild)))
		{
			cout << cur->data << " "; //յջǰڵ
			if (cur == root)//ѵڵ㣬
			{
				free(ls);
				return;
			}
			pre = cur;
			pop(ls, cur);
		}
		else
		{
			if (cur->rchild != NULL)
			{
				push(ls, cur->rchild);//ٱڵѹջ
			}
			if (cur->lchild != NULL)
			{
				push(ls, cur->lchild);//ڵѹջ
			}
		}
	}
}
//ʹõݹ
int Depth(BTree rt)
{
	int deep = 0;
	if (rt)
	{
		int leftdeep = Depth(rt->lchild);
		int rightdeep = Depth(rt->rchild);
		deep = leftdeep >= rightdeep ? leftdeep + 1 : rightdeep + 1;
	}
	return deep;
}
//=============α==========================
typedef struct QueueNode
{
	BTree elem;
	QueueNode* next;
};
typedef struct LinkQueue
{
	QueueNode* front, * rear;
};
bool initQueue(LinkQueue& q)
{
	q.front = q.rear = new QueueNode;
	q.front->next = NULL;
	return true;
}
void EnQueue(LinkQueue& q, BTree e)
{
	QueueNode* s = new QueueNode;
	s->elem = e;
	s->next = NULL;
	q.rear->next = s;
	q.rear = s;
}
bool DeQueue(LinkQueue& q, BTree& e)
{
	if (q.front == q.rear) return false;
	QueueNode* p = q.front->next;
	e = p->elem;
	q.front->next = p->next;
	if (q.rear == p)
		q.rear = q.front;
	free(p);
	return true;
}
bool IsEmpty(LinkQueue q)
{
	if (q.rear == q.front)
		return true;
	return false;
}
void vist(BTree e)
{
	if (e != NULL && e->data != NULL)
		cout << e->data << " ";
	return;
}
void LevelOrder(BTree T)
{
	LinkQueue Q;
	initQueue(Q);
	BTree p;
	EnQueue(Q, T);
	while (!IsEmpty(Q))
	{
		DeQueue(Q, p);
		vist(p);
		if (p->lchild != NULL)
			EnQueue(Q, p->lchild);
		if (p->rchild != NULL)
			EnQueue(Q, p->rchild);
	}
}
//======================
// 
// 
void InThread(ThreadTree& p, ThreadTree& pre)
{
	if (p != NULL)
	{
		InThread(p->lchild, pre);
		if (p->lchild == NULL)
		{
			p->lchild = pre;
			p->ltag = 1;
		}
		if (pre != NULL && pre->rchild == NULL)
		{
			pre->rchild = p;
			pre->rtag = 1;
		}
		pre = p;
		InThread(p->rchild, pre);
	}
}
// 
void CreateInThread(ThreadTree T)
{
	ThreadTree pre = NULL;
	if (T != NULL)
	{
		InThread(T, pre);
		pre->rchild = NULL;
		pre->rtag = 1;
	}
}
ThreadNode* Firstnode(ThreadNode* p)
{
	while (p->ltag == 0)p = p->lchild;
	return p;
}
ThreadNode* Nextnode(ThreadNode* p)
{
	if (p->rtag == 0) return Firstnode(p->rchild);
	else return p->rchild;
}
ThreadNode* Prenode(ThreadNode* p)
{
	if (p->ltag == 0) return Firstnode(p->lchild);
	else return p->lchild;
}
ThreadNode* Endnode(ThreadNode* p)
{
	while (p->rtag == 0)p = p->rchild;
	return p;
}
void Inorder(ThreadNode* T)
{
	for (ThreadNode* p = Firstnode(T); p != NULL; p = Nextnode(p))
		vist(p);
}
//϶¡Ҳα
void InvertLevel(BTree bt)
{
	LinkStack s = new LStack;
	LinkQueue Q;
	BTree p;
	if (bt != NULL)
	{
		InitLS(s);
		initQueue(Q);
		EnQueue(Q, bt);
		while (IsEmpty(Q) == false)
		{
			DeQueue(Q, p);
			push(s, p);
			if (p->lchild)
				EnQueue(Q, p->lchild);
			if (p->rchild)
				EnQueue(Q, p->rchild);
		}
		while (stackempty(s) == false)
		{
			pop(s, p);
			if (p != NULL && p->data != NULL)
				cout << p->data << " ";
		}
	}
}